﻿
namespace ClassesAndStructs
{
    public class CartPoint
    {
        int x;
        public int X
        {
            get { return x; }
            set
            {
                // determine if the incoming value is valid
                if( DataIsValid(value) )
                {
                    x = value;
                }
            }
        }
        int y;
        public int Y
        {
            get { return y; }
            set
            {
                // determine if the incoming value is valid
                if( DataIsValid(value) )
                {
                    y = value;
                }
            }
        }

        /// <summary>
        /// Creates a new CartPoint with the values x and y
        /// </summary>
        /// <param name="x">The x value for the new CartPoint</param>
        /// <param name="y">The y value for the new CartPoint</param>
        public CartPoint(int x, int y)
        {
            this.X = x;
            this.Y = y;
        }

        /// <summary>
        /// Determines whether num is a valid for a CartPoint
        /// </summary>
        /// <param name="num">The number to determine the validity of</param>
        /// <returns></returns>
        bool DataIsValid(int num)
        {
            // return whether it's greater than or equal to 0 and less than or equal to 300
            return num >= 0 && num <= 300;
        }

        /// <summary>
        /// Shifts this CartPoint shiftX and shiftY
        /// </summary>
        /// <param name="shiftX">The shift in the x direction</param>
        /// <param name="shiftY">The shift in the y direction</param>
        public void Mutate_Shift(int shiftX, int shiftY)
        {
            this.X += shiftX;
            this.Y += shiftY;
        }

        /// <summary>
        /// Creates a new CartPoint shifted shiftX and shiftY
        /// </summary>
        /// <param name="shiftX">The shift in the x direction</param>
        /// <param name="shiftY">The shift in the y direction</param>
        /// <returns></returns>
        public CartPoint Create_Shift(int shiftX, int shiftY)
        {
            return new CartPoint(this.X += shiftX, this.Y += shiftY);
        }
    }
}
